//	DrawTextg[hWւ̕\  Direct X 9

#define     szClassName      TEXT("3D_DrawText")

#include <windows.h>
#include <d3dx9.h>
#include <tchar.h>

#pragma once
#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")
#pragma comment(lib,"winmm.lib")

#define SAFE_RELEASE(p)         { if (p) { (p)->Release();  (p)=NULL; } }

typedef struct _D3DVERTEX{
	D3DXVECTOR3 position; // _W
    D3DXVECTOR3 normal;   // @
}   D3DVERTEX;

#define D3DFVF_VERTEX (D3DFVF_XYZ|D3DFVF_NORMAL)


//_tH[}bg

#define D3DFVF_VERTEXCOL  (D3DFVF_XYZ | D3DFVF_DIFFUSE)	//gXtH[ĂȂ_̈ʒuW+fBt[Y J[

typedef struct _D3DVERTEXCOR_ {
	float   x,y,z;	// gXtH[ĂȂ_̈ʒuW
    DWORD   color;	// fBt[Y J[
}	D3DVERTEXCOR;

D3DVERTEXCOR	gauge_x[]={	{  0,0,0,0xffff0000 }
							,{400,0,0,0xffff0000 } };
D3DVERTEXCOR	gauge_y[]={	{  0,0,0,0xff00ff00 },
						{  0,400,0,0xff00ff00 } };

D3DVERTEXCOR	gauge_z[]={	{  0,0,0,0xff0000ff },
						{  0,0,400,0xff0000ff } };

int sx=0;	//	XN[W
int sy=0;

D3DPRESENT_PARAMETERS   D3DPPWin;
LPDIRECT3DDEVICE9       pDEV=0;
LPDIRECT3D9             pD3D=0;
LPD3DXFONT    pFont   = NULL; //tHg


BOOL InitApp(HINSTANCE, WNDPROC, TCHAR*);
BOOL InitInstance(HINSTANCE, TCHAR*, int);
HWND hWnd;
HRESULT InitDevices(HWND hWnd);	// foCX/[h̏
LRESULT WINAPI WndProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);
void Render(void);// `揈
HRESULT InitFont(HWND hWnd);


void Cleanup(void);	// IuWFNg̊J



INT WINAPI _tWinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPTSTR lptsCmdLine, INT nCmdShow){
	MSG     msg;

    if (!hPrevInst) {
        if (!InitApp(hInst,WndProc, szClassName))    //    EBhENX̓o^
            return FALSE;
    }
    if (!InitInstance(hInst, szClassName, nCmdShow)) {    // EBhE̍쐬
        return FALSE;
    }
	
	if (FAILED(InitDevices(hWnd)))
		return FALSE;

    ShowWindow(hWnd,SW_SHOWDEFAULT);
    UpdateWindow(hWnd);
    ZeroMemory(&msg,sizeof(msg));
    while(msg.message!=WM_QUIT){
		if (PeekMessage(&msg,NULL,0U,0U,PM_REMOVE)){
			TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
        else
			Render();
    }
    Cleanup();
    return 0;
}

BOOL InitApp(HINSTANCE hInst,WNDPROC WndProc,TCHAR* Name){
    WNDCLASS wc;
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInst;
    wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = NULL;
    wc.lpszClassName = (TCHAR*)Name;
    return (RegisterClass(&wc));
}

BOOL InitInstance(HINSTANCE hInst, TCHAR* Name, int nCmdShow){
    hWnd = CreateWindow(Name,
            Name,
            WS_OVERLAPPEDWINDOW,
            0,
            0,
            320,
            240,
            NULL,
            NULL,
            hInst,
            NULL);
    if (!hWnd)
        return FALSE;
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    return TRUE;
}

// foCX/[h̏
HRESULT InitDevices(HWND hWnd){
	D3DDISPLAYMODE          dmode;
	HRESULT     hr;

    // foCX/[h̏
    if (pD3D==NULL)
		pD3D = Direct3DCreate9(D3D_SDK_VERSION);
    if (pD3D==NULL)
		return E_FAIL;
    //݂̃fBXvC[h𓾂
    if (FAILED(pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT,&dmode)))
		return E_FAIL;

    // D3DDeviceIuWFNg̍쐬
    ZeroMemory(&D3DPPWin, sizeof(D3DPPWin));
    D3DPPWin.BackBufferFormat           = dmode.Format;
    D3DPPWin.BackBufferCount            = 1;
    D3DPPWin.SwapEffect                 = D3DSWAPEFFECT_DISCARD;
    D3DPPWin.Windowed                   = TRUE;
    D3DPPWin.EnableAutoDepthStencil     = TRUE;
    D3DPPWin.AutoDepthStencilFormat     = D3DFMT_D16;
    D3DPPWin.Flags                      = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;
	
	hr = pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                D3DCREATE_HARDWARE_VERTEXPROCESSING, &D3DPPWin, &pDEV);
    if (FAILED(hr)){
		hr = pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,D3DCREATE_SOFTWARE_VERTEXPROCESSING, &D3DPPWin, &pDEV);
        if (FAILED(hr)){
			hr = pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, &D3DPPWin, &pDEV);
            if (FAILED(hr)){
				MessageBox(NULL,TEXT("Create Device Error"),TEXT("Surface Error"),MB_OK);
				return E_FAIL;
			}
        }
    }
	InitFont(hWnd);
    return S_OK;
}


LRESULT WINAPI WndProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam){
    switch(msg){
		case WM_SIZE:
			sx = LOWORD(lParam);  // NCAg̈̕ 
			sy = HIWORD(lParam); // NCAg̈̍ 
			break;
	   case WM_DESTROY:
            PostQuitMessage(0);
            return 0;
    }
    return DefWindowProc(hWnd,msg,wParam,lParam);
}


// `揈
void Render(void){
	D3DXMATRIX matWorld;
    D3DXMATRIX matView;
    D3DXMATRIX matProj;
    pDEV->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
    pDEV->BeginScene();


	D3DVIEWPORT9 vp;
	vp.X  = 0;
	vp.Y  = 0;
	vp.Width = D3DPPWin.BackBufferWidth;
	vp.Height =D3DPPWin.BackBufferHeight;
	vp.MinZ  = 0.0f;
	vp.MaxZ  = 1.0f;

	D3DXMatrixIdentity(&matView);
    D3DXMatrixIdentity(&matProj);
	D3DXMatrixLookAtLH(&matView, &D3DXVECTOR3( 1000, 1000,-1000),
		&D3DXVECTOR3(0,0,0), &D3DXVECTOR3( 0.0f, 1.0f, 0.0f));
    pDEV->SetTransform(D3DTS_VIEW, &matView);
    D3DXMatrixPerspectiveFovLH(&matProj, D3DX_PI/4, float(sx)/float(sy), -1000,0);
	pDEV->SetTransform(D3DTS_PROJECTION, &matProj);

	pDEV->SetRenderState(D3DRS_CULLMODE,D3DCULL_CCW);		//v̖ʂ
    pDEV->SetRenderState(D3DRS_LIGHTING,FALSE);         	//CeBOȂ
    pDEV->SetRenderState(D3DRS_ZENABLE,D3DZB_FALSE);    	//Zobt@gȂ

	pDEV->SetFVF(D3DFVF_VERTEXCOL);
	pDEV->DrawPrimitiveUP(D3DPT_LINELIST,1,gauge_x,sizeof(D3DVERTEXCOR));
	pDEV->DrawPrimitiveUP(D3DPT_LINELIST,1,gauge_y,sizeof(D3DVERTEXCOR));
	pDEV->DrawPrimitiveUP(D3DPT_LINELIST,1,gauge_z,sizeof(D3DVERTEXCOR));

	D3DXVECTOR3 wvec,vec;
	D3DXMATRIX matW;
	RECT rect;

	D3DXMatrixIdentity( &matW);

	wvec.x=0;
	wvec.y=0;
	wvec.z=0;
	D3DXVec3Project(&vec,   &wvec, &vp, &matProj, &matView, &matW );
	SetRect(&rect ,int(vec.x)  , int(vec.y) , 100,20);
	pFont->DrawText(NULL, TEXT("0,0,0"), -1, &rect, DT_LEFT | DT_NOCLIP, D3DCOLOR_ARGB(255, 255, 255, 255));


	wvec.x=gauge_x[1].x;
	wvec.y=gauge_x[1].y;
	wvec.z=gauge_x[1].z;
	D3DXVec3Project(&vec,   &wvec, &vp, &matProj, &matView, &matW );
	SetRect(&rect ,int(vec.x)  , int(vec.y) , 100,20);
	pFont->DrawText(NULL, TEXT("500,0,0"), -1, &rect, DT_LEFT | DT_NOCLIP, D3DCOLOR_ARGB(255, 255, 0, 0));
  

	wvec.x=gauge_y[1].x;
	wvec.y=gauge_y[1].y;
	wvec.z=gauge_y[1].z;
	D3DXVec3Project(&vec,   &wvec, &vp, &matProj, &matView, &matW );
	SetRect(&rect ,int(vec.x)  , int(vec.y) , 100,20);
	pFont->DrawText(NULL, TEXT("0,500,0"), -1, &rect, DT_LEFT | DT_NOCLIP, D3DCOLOR_ARGB(255, 0, 255, 0));

	wvec.x=gauge_z[1].x;
	wvec.y=gauge_z[1].y;
	wvec.z=gauge_z[1].z;
	D3DXVec3Project(&vec,   &wvec, &vp, &matProj, &matView, &matW );
	SetRect(&rect ,int(vec.x)  , int(vec.y) , 100,20);
	pFont->DrawText(NULL, TEXT("0,0,500"), -1, &rect, DT_LEFT | DT_NOCLIP, D3DCOLOR_ARGB(255, 0, 0, 255));


	pDEV->EndScene();
    pDEV->Present(NULL,NULL,NULL,NULL);
}

// IuWFNg̊J
void Cleanup(void){
    SAFE_RELEASE(pFont);
    SAFE_RELEASE(pDEV);
    SAFE_RELEASE(pD3D);
}
	
//tHg̏
HRESULT InitFont(HWND hWnd){
	HRESULT hr = D3DXCreateFont( pDEV, 20, 0, FW_HEAVY, 1, false, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS,
		ANTIALIASED_QUALITY, FF_DONTCARE, TEXT("lr "), &pFont );
	if FAILED(hr){
		return(E_FAIL);
	}
	return S_OK;
}

